#!/usr/bin/perl
use lib 'lib/';
use Gtk2 -init;
use Gtk2::FormFactory;
use Data::Dumper;
use strict;

my $window = Gtk2::Window->new('toplevel');
$window->signal_connect('delete_event', \&close_program);
$window->set_position('center');
$window->set_title('Gtk2::FormFactory test');

my $form = Gtk2::FormFactory->new;

$form->set_items(
	{
		text		=> 'Text String:',
		type		=> 'string',
		value		=> 'Hello World!',
	},
	{
		text		=> 'Integer:',
		type		=> 'int',
		value		=> 69,
		min		=> 0,
		max		=> 100,
		step		=> 1
	},
	{
		text		=> 'Float:',
		type		=> 'float',
		value		=> 42.012,
		min		=> 0,
		max		=> 100,
		step		=> 1,
		precision	=> 3,
	},
	{
		text		=> 'Enum:',
		type		=> 'enum',
		values		=> [ 'Foo', 'Bar', 'Fish', 'Bang' ],
		value		=> 'Fish',
	},
	{
		text		=> 'File:',
		type		=> 'file',
		value		=> $0,
		title		=> 'Select file:',
		button		=> 'Browse...',
	},
	{
		text		=> 'Font:',
		type		=> 'font',
		value		=> 'Sans 10',
		title		=> 'Select font:',
	},
	{
		text		=> 'Boolean:',
		type		=> 'boolean',
		checked		=> 1,
	},
	{
		text		=> 'Multiple:',
		type		=> 'multiple',
		values		=> [ 'Foo', 'Bar', 'Fish', 'Bang' ],
		selected	=> [ 'Fish' ],
	},
	{
		text		=> 'Text Entry:',
		type		=> 'text',
		value		=> 'There is no spoon.',
	},
);

$form->set_label_align('left', 'middle');

$form->generate;

$form->get_label(7)->set_alignment(0, 0);
$form->get_label(8)->set_alignment(0, 0);

$window->add($form->get_widget);

$window->show_all;

Gtk2->main;

exit;

sub close_program {
	print "form values: ".join(", ", $form->get_values)."\n";
	exit;
}
